/* -- Sprites.h --
Part of the Worminator 2D game engine
Copyright 2002 by Electroencephlogram Software

For function descriptions and explanations, see proto.h
For a detailed explanation of how the engine works, see
the documents that came with this source code package. */

// Projectiles
#define WORMINATOR_BULLET_SPRITE 1
#define WORMINATOR_ROCKET_SPRITE 2
#define WORMINATOR_MORTAR_SPRITE 3
#define WORMINATOR_BFG_PLASMA_BALL_SPRITE 4
#define WORMINATOR_MINE_SPRITE 5
#define ENEMY_PLASMA_BULLET_SPRITE 6
#define ENEMY_LASER_BOLT_SPRITE 7
#define SMALL_ENEMY_ROCKET_SPRITE 8
#define LARGE_ENEMY_ROCKET_SPRITE 9
#define ENEMY_MORTAR_SPRITE 10
#define ENEMY_TOXIN_SPRITE 11
#define WORMINATOR_PLASMA_BULLET_SPRITE 12
#define WORMINATOR_SPIKESTAR_SPRITE 13
#define WORMINATOR_MICRO_NUKE_SPRITE 14
#define WORMINATOR_WALKING_MINE_SPRITE 15
#define ENEMY_MISSILE_SPRITE 512
#define ENEMY_EGG_SPRITE 513
#define FIREWORK_SPRITE 514
#define BOTTLE_ROCKET_SPRITE 515
#define GIANT_ROCKET_SPRITE 516
#define TANK_SHELL_SPRITE 517

// Particles and stuff that does basically nothing
#define BONUS_FLYUP_50_POINT_SPRITE 16
#define BONUS_FLYUP_100_POINT_SPRITE 17
#define BONUS_FLYUP_250_POINT_SPRITE 18
#define BONUS_FLYUP_500_POINT_SPRITE 19
#define SMALL_WHITE_SPARK_SPRITE 20
#define SMALL_BLUE_SPARK_SPRITE 21
#define SMALL_RED_SPARK_SPRITE 22
#define SMALL_GOLD_SPARK_SPRITE 23
#define WATER_BUBBLE_SPRITE 24
#define WATER_SPLASH_SPRITE 25
#define SHRAPNEL_SPRITE 26
#define GIB_SPRITE 27
#define SMALL_SPINNING_FAN_SPRITE 28
#define MEDIUM_SPINNING_FAN_SPRITE 29
#define LARGE_SPINNING_FAN_SPRITE 30
#define STARDUST_PARTICLE_SPRITE 31

// Enemies
#define BLUE_SLIME_ENEMY_SPRITE 32
#define SMALL_RUNNER_ENEMY_SPRITE 33
#define ROBOTIC_DOG_ENEMY_SPRITE 34
#define SMALL_GUN_TURRET_ENEMY_SPRITE 35
#define MORTAR_GUN_TURRET_ENEMY_SPRITE 36
#define BIG_GUN_TURRET_ENEMY_SPRITE 37
#define FLYING_PROBE_ENEMY_SPRITE 38
#define DECIMATER_ENEMY_SPRITE 39
#define GIANT_ROBOT_ENEMY_SPRITE 40
#define MECHANICAL_CRUSHER_ENEMY_SPRITE 41
#define NUCLEAR_WORM_ENEMY_SPRITE 42
#define LASER_REBEL_WORM_ENEMY_SPRITE 43
#define ROCKET_REBEL_WORM_ENEMY_SPRITE 44
#define RIFLE_REBEL_WORM_ENEMY_SPRITE 45
#define BIG_GREEN_SLIME_BLOB_ENEMY_SPRITE 46
#define GUMDROP_ENEMY_SPRITE 47
#define BIG_NUCLEAR_BOMB_ENEMY_SPRITE 48
#define SMALL_NUCLEAR_BOMB_ENEMY_SPRITE 49
#define FIREWORM_SEGMENT_ENEMY_SPRITE 50
#define FLAME_JET_ENEMY_SPRITE 51
#define WORM_CANNON_ENEMY_SPRITE 52
#define ARAB_WORM_ENEMY_SPRITE 53
#define WERMAID_ENEMY_SPRITE 54
#define HEAVY_WEAPON_REBEL_WORM_ENEMY_SPRITE 55
#define THUG_WORM_ENEMY_SPRITE 56
#define PUNK_WORM_ENEMY_SPRITE 57
#define POLICE_WORM_ENEMY_SPRITE 58
#define INCINERATOR_ENEMY_SPRITE 59
#define SPEAR_TAPEWORM_ENEMY_SPRITE 60
#define EGG_TAPEWORM_ENEMY_SPRITE 61
#define BOULDER_ENEMY_SPRITE 62
#define BOSS_ENEMY_SPRITE 63
#define STOMPING_FOOT_ENEMY_SPRITE 400
#define CIGARETTE_BUTT_ENEMY_SPRITE 401

// Civilians
#define WORM_GIRL_SPRITE 64
#define WORM_BOY_SPRITE 65
#define WORM_COP_SPRITE 66
#define WORM_GENTLEMEN_SPRITE 67
#define WORM_BLONDE_DRESSED_SPRITE 68
#define WORM_STRIPPER_ONE_SPRITE 69
#define WORM_STRIPPER_TWO_SPRITE 70
#define WORM_BLONDE_NUDE_ONE_SPRITE 71
#define WORM_BLONDE_NUDE_TWO_SPRITE 72
#define WORM_BLONDE_IN_BED_SPRITE 73
#define WORM_BLONDE_DANCER_SPRITE 74

// Explosions
#define SMALL_EXPLOSION_SPRITE 80
#define MEDIUM_EXPLOSION_SPRITE 81
#define MUSHROOM_CLOUD_SPRITE 82
#define BFG_PLASMA_BALL_EXPLOSION_SPRITE 83
#define EXPLODING_CAR_01_SPRITE 84
#define EXPLODING_CAR_02_SPRITE 85

// Getable items
#define HEALTH_1_SPRITE 96
#define HEALTH_2_SPRITE 97
#define HEALTH_5_SPRITE 98
#define HEALTH_10_SPRITE 99
#define MINIGUN_SPRITE 100
#define BULLETS_SMALL_SPRITE 101
#define BULLETS_LARGE_SPRITE 102
#define SHOTGUN_SPRITE 103
#define SHELLS_SMALL_SPRITE 104
#define SHELLS_LARGE_SPRITE 105
#define ROCKET_LAUNCHER_SPRITE 106
#define ROCKETS_SMALL_SPRITE 107
#define ROCKETS_LARGE_SPRITE 108
#define LASER_GUN_SPRITE 109
#define CELLS_SMALL_SPRITE 110
#define CELLS_LARGE_SPRITE 111
#define FLAMETHROWER_SPRITE 112
#define GASOLINE_SMALL_SPRITE 113
#define GASOLINE_LARGE_SPRITE 114
#define MORTAR_CANNON_SPRITE 115
#define MORTARS_SMALL_SPRITE 116
#define MORTARS_LARGE_SPRITE 117
#define BFG_SPRITE 118
#define PLASMA_SMALL_SPRITE 119
#define PLASMA_LARGE_SPRITE 120
#define MINELAYER_SPRITE 121
#define MINES_SMALL_SPRITE 122
#define MINES_LARGE_SPRITE 123
#define RED_KEYCARD_SPRITE 124
#define GREEN_KEYCARD_SPRITE 125
#define BLUE_KEYCARD_SPRITE 126
#define LETTER_W_SPRITE 127
#define LETTER_O_SPRITE 128
#define LETTER_R_SPRITE 129
#define LETTER_M_SPRITE 130
#define SODA_SIXPACK_SPRITE 131
#define DOUGHNUTS_SPRITE 132
#define BOX_OF_DOUGHNUTS_SPRITE 133
#define MUD_BEER_SPRITE 134

// Misc stuff
#define FLOATING_PLATFORM_SPRITE 144
#define SMALL_EXPLOSIVE_BARREL_SPRITE 145
#define SMALL_EXPLOSIVE_NUCLEAR_CRATE_SPRITE 146
#define PUSHABLE_CRATE_SPRITE 147
#define PERVERT_MESSAGE_SPRITE 148
#define GREY_DOOR_SPRITE 149
#define RED_DOOR_SPRITE 150
#define RED_DOOR_TOP_SPRITE 151
#define RED_DOOR_BOTTOM_SPRITE 152
#define GREEN_DOOR_SPRITE 153
#define GREEN_DOOR_TOP_SPRITE 154
#define GREEN_DOOR_BOTTOM_SPRITE 155
#define BLUE_DOOR_SPRITE 156
#define SMALL_FLAME_SPRITE 157
#define WATER_DROP_SPRITE 158
#define BORED_SPRITE 159
#define DAMAGE_MARKER 666
#define TICK_SPRITE 400
#define DEER_SPRITE 401

// Spawners
#define BLUE_SPARK_SPAWNER_SPRITE 160
#define RED_SPARK_SPAWNER_SPRITE 161
#define WHITE_SPARK_SPAWNER_SPRITE 162
#define GOLD_SPARK_SPAWNER_SPRITE 163
#define WATER_DROP_SPAWNER_SPRITE 164
#define NUCLEAR_BOMB_SPAWNER_SPRITE 165
#define RANDOM_REBEL_WORM_SPAWNER_SPRITE 166
#define ARCSPARK_SPRITE 167
#define FIREWORK_SPAWNER_SPRITE 168
#define BOTTLE_ROCKET_SPAWNER_SPRITE 169
#define CIGARETTE_BUTT_SPAWNER_SPRITE 170

// Worminator 2 items
#define PLASMA_BULLETS_SMALL_SPRITE 176
#define PLASMA_BULLETS_LARGE_SPRITE 177
#define EXPLOSIVE_SHELLS_SMALL_SPRITE 178
#define EXPLOSIVE_SHELLS_LARGE_SPRITE 179
#define MICRO_NUKE_SPRITE 180
#define WALKING_MINES_SMALL_SPRITE 181
#define WALKING_MINES_LARGE_SPRITE 182
#define CHAINSAW_SPRITE 183
#define RAILGUN_SPRITE 184
#define RAILS_SMALL_SPRITE 185
#define RAILS_LARGE_SPRITE 186
#define STARDUSTER_SPRITE 187
#define SPIKESTARS_SPRITE 188
#define TANK_SPRITE 189
#define DIRT_CHIPS_SPRITE 190
#define MUD_ICE_CREAM_SPRITE 191
#define MINI_MOUNT_N_DO_SPRITE 192
#define MUD_PIE_SPRITE 193
#define BIG_TASTY_BALL_O_DIRT_SPRITE 194
#define LIFE_ESSENCE_SPRITE 195

#define DARK_PALETTE_EFFECT_SPRITE 200
#define LIGHT_PALETTE_EFFECT_SPRITE 201

#include "projectile_ai.h"  // Ai for bullets, rockets, lasers, etc...
#include "particle_ai.h"  // Ai for particle effects like sparks and shrapnel
#include "enemy_ai.h"  // Ai for all the enemies in the game
#include "civilian_ai.h"  // Ai for all the civilian worms, like the cops
#include "item_ai.h"   // Ai for powerups and other gettable krap
#include "misc_ai.h"   // Ai for everything else, like platforms and crates
#include "spawn_ai.h"  // Ai for spawning objects

/******************\
|** SPAWN SPRITE **|
\******************/
void spawn_sprite(int sprite_type, int x_position_in_pixels, int y_position_in_pixels, float x_acceleration, float y_acceleration, unsigned char direction)
{
int sprite_loop;

if (number_of_sprites >= 1023) return;

for (sprite_loop = 0; sprite_loop < 1024; sprite_loop++) {
	if (sprites[sprite_loop].sprite_active == 0) {
		number_of_sprites++;
		sprites[sprite_loop].sprite_active = 1;  // This applies to all sprites
		sprites[sprite_loop].sprite_type = sprite_type;  // This applies to all sprites

		// Scan all sprite types and pick one
		if (sprite_type == WORMINATOR_BULLET_SPRITE) {
			sprites[sprite_loop].timer = 128;
			sprites[sprite_loop].width = 4, sprites[sprite_loop].height = 1;
			sprites[sprite_loop].frame = WORMINATOR_BULLET_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORMINATOR_ROCKET_SPRITE) {
			sprites[sprite_loop].width = 15, sprites[sprite_loop].height = 9;
			sprites[sprite_loop].frame = WORMINATOR_ROCKET_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORMINATOR_MORTAR_SPRITE) {
			sprites[sprite_loop].timer = 512 + rand() % 256;
			sprites[sprite_loop].width = 13, sprites[sprite_loop].height = 13;
			sprites[sprite_loop].frame = WORMINATOR_MORTAR_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORMINATOR_BFG_PLASMA_BALL_SPRITE) {
			sprites[sprite_loop].timer = 8;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = BFG_PLASMA_BALL_FLY_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORMINATOR_MINE_SPRITE) {
			sprites[sprite_loop].timer = 256;
			sprites[sprite_loop].width = 10, sprites[sprite_loop].height = 5;
			sprites[sprite_loop].frame = WORMINATOR_MINE_ARM;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == ENEMY_PLASMA_BULLET_SPRITE) {
			sprites[sprite_loop].timer = 128;
			sprites[sprite_loop].width = 4, sprites[sprite_loop].height = 1;
			sprites[sprite_loop].frame = ENEMY_PLASMA_BULLET_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].direction = direction;
			play_relative_sound(PLASMA_BULLET_FIRE_SOUND, sprite_loop);
			}

		else if (sprite_type == ENEMY_LASER_BOLT_SPRITE) {
			sprites[sprite_loop].timer = 192;  // Lasers have a range limit of 12 squares
			sprites[sprite_loop].width = 8, sprites[sprite_loop].height = 3;
			sprites[sprite_loop].frame = ENEMY_LASER_BOLT_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			play_relative_sound(LASER_BOLT_FIRE_SOUND, sprite_loop);
			}

		else if (sprite_type == SMALL_ENEMY_ROCKET_SPRITE) {
			sprites[sprite_loop].width = 14, sprites[sprite_loop].height = 7;
			sprites[sprite_loop].frame = SMALL_ENEMY_ROCKET_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == LARGE_ENEMY_ROCKET_SPRITE) {
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 8;
			sprites[sprite_loop].frame = LARGE_ENEMY_ROCKET_FLY_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == ENEMY_MORTAR_SPRITE) {
			sprites[sprite_loop].timer = 512 + rand() % 256;
			sprites[sprite_loop].width = 12, sprites[sprite_loop].height = 13;
			sprites[sprite_loop].frame = ENEMY_MORTAR_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == ENEMY_TOXIN_SPRITE) {
			sprites[sprite_loop].width = 15, sprites[sprite_loop].height = 3;
			sprites[sprite_loop].frame = ENEMY_TOXIN_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORMINATOR_PLASMA_BULLET_SPRITE) {
			sprites[sprite_loop].timer = 128;
			sprites[sprite_loop].width = 10, sprites[sprite_loop].height = 5;
			sprites[sprite_loop].frame = WORMINATOR_PLASMA_BULLET_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORMINATOR_SPIKESTAR_SPRITE) {
			sprites[sprite_loop].timer = 128;
			sprites[sprite_loop].width = 5, sprites[sprite_loop].height = 5;
			sprites[sprite_loop].frame = 0;  // Set this after spawned to allow all 3 colors
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORMINATOR_MICRO_NUKE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 14;
			sprites[sprite_loop].frame = WORMINATOR_MICRO_NUKE_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORMINATOR_WALKING_MINE_SPRITE) {
			sprites[sprite_loop].timer = 256;
			sprites[sprite_loop].width = 10, sprites[sprite_loop].height = 8;
			sprites[sprite_loop].frame = WORMINATOR_WALKING_MINE_ARM;
			sprites[sprite_loop].hit_points_left = .25;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == ENEMY_MISSILE_SPRITE) {
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ENEMY_MISSILE_FLY_01;
			//sprites[sprite_loop].hit_points_left = .5;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == ENEMY_EGG_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].frame = ENEMY_EGG_FLY;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == FIREWORK_SPRITE) {
			sprites[sprite_loop].timer = 128 + rand() % 128;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].animation_state = 60 + rand() % 60;
			sprites[sprite_loop].frame = FIREWORK_REST;
			sprites[sprite_loop].hit_points_left = .5;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = 0;
			sprites[sprite_loop].y_acceleration = -.95;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == BOTTLE_ROCKET_SPRITE) {
			sprites[sprite_loop].timer = 128 + rand() % 128;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].action_state = 60 + rand() % 60;
			sprites[sprite_loop].frame = BOTTLE_ROCKET_REST;
			sprites[sprite_loop].hit_points_left = .5;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = 0;
			sprites[sprite_loop].y_acceleration = -.95;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == GIANT_ROCKET_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 112;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].frame = GIANT_ROCKET_REST;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = 0;
			sprites[sprite_loop].y_acceleration = 0;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == TANK_SHELL_SPRITE) {
			sprites[sprite_loop].width = 48, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].frame = TANK_SHELL_FLY_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == BONUS_FLYUP_50_POINT_SPRITE || sprite_type == BONUS_FLYUP_100_POINT_SPRITE || sprite_type == BONUS_FLYUP_250_POINT_SPRITE || sprite_type == BONUS_FLYUP_500_POINT_SPRITE) {
			sprites[sprite_loop].timer = 256;  // Flyup sprites die after 256 frames
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 5;
			if (sprite_type == BONUS_FLYUP_50_POINT_SPRITE) sprites[sprite_loop].frame = BONUS_FLYUP_50_POINT;
			if (sprite_type == BONUS_FLYUP_100_POINT_SPRITE) sprites[sprite_loop].frame = BONUS_FLYUP_100_POINT;
			if (sprite_type == BONUS_FLYUP_250_POINT_SPRITE) sprites[sprite_loop].frame = BONUS_FLYUP_250_POINT;
			if (sprite_type == BONUS_FLYUP_500_POINT_SPRITE) sprites[sprite_loop].frame = BONUS_FLYUP_500_POINT;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == SMALL_WHITE_SPARK_SPRITE || sprite_type == SMALL_BLUE_SPARK_SPRITE || sprite_type == SMALL_RED_SPARK_SPRITE || sprite_type == SMALL_GOLD_SPARK_SPRITE) {
			sprites[sprite_loop].timer = 32;  // Sparks hang around for 32 * 3 frames
			sprites[sprite_loop].width = 3, sprites[sprite_loop].height = 3;
			if (sprite_type == SMALL_WHITE_SPARK_SPRITE) sprites[sprite_loop].frame = SMALL_WHITE_SPARK_01;
			if (sprite_type == SMALL_BLUE_SPARK_SPRITE) sprites[sprite_loop].frame = SMALL_BLUE_SPARK_01;
			if (sprite_type == SMALL_RED_SPARK_SPRITE) sprites[sprite_loop].frame = SMALL_RED_SPARK_01;
			if (sprite_type == SMALL_GOLD_SPARK_SPRITE) sprites[sprite_loop].frame = SMALL_GOLD_SPARK_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			}

		else if (sprite_type == WATER_BUBBLE_SPRITE) {
			sprites[sprite_loop].frame = WATER_BUBBLE_01 + (rand() % 4);
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			}

		else if (sprite_type == WATER_SPLASH_SPRITE) {
			sprites[sprite_loop].timer = 8;
			sprites[sprite_loop].frame = WATER_SPLASH_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			}

		else if (sprite_type == SHRAPNEL_SPRITE) {
			sprites[sprite_loop].timer = 256;
			sprites[sprite_loop].frame = SHRAPNEL_01 + (rand() % 8);
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			}

		else if (sprite_type == GIB_SPRITE) {
			sprites[sprite_loop].timer = 256;
			sprites[sprite_loop].frame = GIB_01 + (rand() % 10);
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			}

		else if (sprite_type == FLOATING_PLATFORM_SPRITE) {
			sprites[sprite_loop].timer = 0;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 4;
			sprites[sprite_loop].frame = FLOATING_PLATFORM_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == BLUE_SLIME_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 128;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].width = 24, sprites[sprite_loop].height = 24;
			sprites[sprite_loop].frame = BLUE_SLIME_REST;
			sprites[sprite_loop].hit_points_left = 24;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels - 4;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels - 4;
			sprites[sprite_loop].direction = direction;
			if (worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] == up_turning_point_info_tile) {
				sprites[sprite_loop].animation_state = 2;
				worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] = 0;
				}
			else sprites[sprite_loop].animation_state = 1;
			}

		else if (sprite_type == SMALL_RUNNER_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 24;
			sprites[sprite_loop].frame = SMALL_RUNNER_RUN_01;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 8;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .8;
			else sprites[sprite_loop].x_acceleration = -.8;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == ROBOTIC_DOG_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 24;
			sprites[sprite_loop].frame = ROBOTIC_DOG_WALK_01;
			sprites[sprite_loop].hit_points_left = 4;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 8;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .75;
			else sprites[sprite_loop].x_acceleration = -.75;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == SMALL_GUN_TURRET_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = SMALL_GUN_TURRET_REST;
			sprites[sprite_loop].hit_points_left = 6;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == MORTAR_GUN_TURRET_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 48, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = MORTAR_GUN_TURRET_REST;
			sprites[sprite_loop].hit_points_left = 12;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == BIG_GUN_TURRET_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 48, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = BIG_GUN_TURRET_REST;
			sprites[sprite_loop].hit_points_left = 18;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == FLYING_PROBE_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = (rand() % 512) + 256;
			sprites[sprite_loop].width = 24, sprites[sprite_loop].height = 24;
			sprites[sprite_loop].frame = FLYING_PROBE_FLY;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels - 4;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels - 4;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .5;
			else sprites[sprite_loop].x_acceleration = -.5;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == DECIMATER_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 48, sprites[sprite_loop].height = 48;
			sprites[sprite_loop].frame = DECIMATER_WALK_01;
			sprites[sprite_loop].hit_points_left = 15;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .75;
			else sprites[sprite_loop].x_acceleration = -.75;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == GIANT_ROBOT_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 64, sprites[sprite_loop].height = 64;
			sprites[sprite_loop].frame = GIANT_ROBOT_WALK_03;
			sprites[sprite_loop].hit_points_left = 50;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .25;
			else sprites[sprite_loop].x_acceleration = -.25;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == MECHANICAL_CRUSHER_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 256;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 96;
			sprites[sprite_loop].frame = MECHANICAL_CRUSHER;
			sprites[sprite_loop].hit_points_left = 666;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == NUCLEAR_WORM_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 24;
			sprites[sprite_loop].width = 24, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = NUCLEAR_WORM_WALK_01;
			sprites[sprite_loop].hit_points_left = 5;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .95;
			else sprites[sprite_loop].x_acceleration = -.95;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == LASER_REBEL_WORM_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = (rand() % 256) + 128;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = LASER_REBEL_WORM_WALK_02;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .75;
			else sprites[sprite_loop].x_acceleration = -.75;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == ROCKET_REBEL_WORM_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = (rand() % 256) + 128;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = ROCKET_REBEL_WORM_WALK_02;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .75;
			else sprites[sprite_loop].x_acceleration = -.75;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == RIFLE_REBEL_WORM_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = RIFLE_REBEL_WORM_WALK_02;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .75;
			else sprites[sprite_loop].x_acceleration = -.75;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == BIG_GREEN_SLIME_BLOB_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 96, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = BIG_GREEN_SLIME_BLOB_01;
			sprites[sprite_loop].hit_points_left = 666;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .1;
			else sprites[sprite_loop].x_acceleration = -.1;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == GUMDROP_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = GUMDROP_MOVE_01;
			sprites[sprite_loop].hit_points_left = .25;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .4;
			else sprites[sprite_loop].x_acceleration = -.4;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == BIG_NUCLEAR_BOMB_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 48;
			sprites[sprite_loop].frame = BIG_NUCLEAR_BOMB;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			play_relative_sound(BOMB_FALLING_SOUND, sprite_loop);
			}

		else if (sprite_type == SMALL_NUCLEAR_BOMB_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = SMALL_NUCLEAR_BOMB;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			play_relative_sound(BOMB_FALLING_SOUND, sprite_loop);
			}

		else if (sprite_type == FIREWORM_SEGMENT_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 8;
			sprites[sprite_loop].width = 8, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = SMALL_FLAME_BURN_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 4;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .5;
			else sprites[sprite_loop].x_acceleration = -.5;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == FLAME_JET_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 64 + (rand() % 64);
			sprites[sprite_loop].width = 96, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORM_CANNON_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 96, sprites[sprite_loop].height = 48;
			sprites[sprite_loop].frame = WORM_CANNON_REST;
			sprites[sprite_loop].hit_points_left = 50;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == ARAB_WORM_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 48, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ARAB_WORM_FLY_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WERMAID_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 48, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = WERMAID_SWIM_01;
			sprites[sprite_loop].hit_points_left = 4;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = 1;
			else sprites[sprite_loop].x_acceleration = -1;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == HEAVY_WEAPON_REBEL_WORM_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = HEAVY_WEAPON_REBEL_WORM_WALK_01;
			sprites[sprite_loop].hit_points_left = 8;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .5;
			else sprites[sprite_loop].x_acceleration = -.5;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == THUG_WORM_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = THUG_WORM_WALK_01;
			sprites[sprite_loop].hit_points_left = 3;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .6;
			else sprites[sprite_loop].x_acceleration = -.6;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == PUNK_WORM_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = PUNK_WORM_WALK_01;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .8;
			else sprites[sprite_loop].x_acceleration = -.8;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == SPEAR_TAPEWORM_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = SPEAR_TAPEWORM_WALK_01;
			sprites[sprite_loop].hit_points_left = 1;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .75;
			else sprites[sprite_loop].x_acceleration = -.75;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == EGG_TAPEWORM_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = EGG_TAPEWORM_WALK_01;
			sprites[sprite_loop].hit_points_left = .8;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .5;
			else sprites[sprite_loop].x_acceleration = -.5;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == BOULDER_ENEMY_SPRITE) {
			sprites[sprite_loop].width = 64, sprites[sprite_loop].height = 56;
			sprites[sprite_loop].frame = BOULDER_01;
			sprites[sprite_loop].hit_points_left = 0;//666;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .45;
			else sprites[sprite_loop].x_acceleration = -.45;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == STOMPING_FOOT_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 256;
			sprites[sprite_loop].animation_state = 3;
			sprites[sprite_loop].width = 384, sprites[sprite_loop].height = 608;
			if (direction == 0) sprites[sprite_loop].frame = STOMPING_FOOT_02;
			else sprites[sprite_loop].frame = STOMPING_FOOT_01;
			sprites[sprite_loop].hit_points_left = 666;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = 0;
			}

		else if (sprite_type == CIGARETTE_BUTT_ENEMY_SPRITE) {
			sprites[sprite_loop].timer = 0;
			sprites[sprite_loop].width = 48; sprites[sprite_loop].height = 32;
			if (rand() % 10 > 4) sprites[sprite_loop].frame = CIGARETTE_BUTT_01;
			else sprites[sprite_loop].frame = CIGARETTE_BUTT_02;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			sprites[sprite_loop].direction = 0;
			}

		else if (sprite_type == BOSS_ENEMY_SPRITE) {
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].width = 96, sprites[sprite_loop].height = 96;
			sprites[sprite_loop].frame = BOSS_WALK_01;
			sprites[sprite_loop].hit_points_left = 200;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (direction == 0) sprites[sprite_loop].x_acceleration = .25;
			else sprites[sprite_loop].x_acceleration = -.25;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == WORM_GIRL_SPRITE) {
			sprites[sprite_loop].timer = 64;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].width = 24, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = WORM_GIRL_STAND;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] == left_turning_point_info_tile) {
				sprites[sprite_loop].direction = 1;
				worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] = 0;
				}
			else sprites[sprite_loop].direction = 0;
			}

		else if (sprite_type == WORM_BOY_SPRITE) {
			sprites[sprite_loop].timer = 64;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].width = 24, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = WORM_BOY_STAND;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] == left_turning_point_info_tile) {
				sprites[sprite_loop].direction = 1;
				worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] = 0;
				}
			else sprites[sprite_loop].direction = 0;
			}

		else if (sprite_type == WORM_STRIPPER_ONE_SPRITE) {
			sprites[sprite_loop].timer = 8;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = WORM_STRIPPER_ONE_REST;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] == left_turning_point_info_tile) {
				sprites[sprite_loop].direction = 1;
				worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] = 0;
				}
			else sprites[sprite_loop].direction = 0;
			}

		else if (sprite_type == WORM_BLONDE_NUDE_ONE_SPRITE) {
			sprites[sprite_loop].timer = 8;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = WORM_BLONDE_NUDE_ONE_REST;
			sprites[sprite_loop].hit_points_left = 2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			if (worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] == left_turning_point_info_tile) {
				sprites[sprite_loop].direction = 1;
				worminator_map.info_tile_grid[x_position_in_pixels / 16][y_position_in_pixels / 16] = 0;
				}
			else sprites[sprite_loop].direction = 0;
			}

		else if (sprite_type == SMALL_EXPLOSION_SPRITE) {
			sprites[sprite_loop].timer = 4;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (rand() % 64 >= 32) sprites[sprite_loop].frame = SMALL_EXPLOSION_01;
			else sprites[sprite_loop].frame = NEW_SMALL_EXPLOSION_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			do_damage(x_position_in_pixels - 4, y_position_in_pixels - 4, 24, 24, 1);
			}

		else if (sprite_type == MEDIUM_EXPLOSION_SPRITE) {
			sprites[sprite_loop].timer = 4;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			if (rand() % 64 >= 32) sprites[sprite_loop].frame = MEDIUM_EXPLOSION_01;
			else sprites[sprite_loop].frame = NEW_MEDIUM_EXPLOSION_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			do_damage(x_position_in_pixels, y_position_in_pixels, 32, 32, 1);
			}

		else if (sprite_type == BFG_PLASMA_BALL_EXPLOSION_SPRITE) {
			sprites[sprite_loop].timer = 12;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = BFG_PLASMA_BALL_EXPLODE_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels - 4;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels - 4;
			do_damage(x_position_in_pixels, y_position_in_pixels, 40, 40, 25);
			}

		else if (sprite_type == EXPLODING_CAR_01_SPRITE) {
			sprites[sprite_loop].width = 80, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].frame = CAR_01_REST;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == EXPLODING_CAR_02_SPRITE) {
			sprites[sprite_loop].width = 64, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].action_state = 0;
			sprites[sprite_loop].frame = CAR_02_REST;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == SMALL_EXPLOSIVE_BARREL_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = SMALL_EXPLOSIVE_BARREL;
			sprites[sprite_loop].hit_points_left = .5;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == SMALL_EXPLOSIVE_NUCLEAR_CRATE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = SMALL_EXPLOSIVE_NUCLEAR_CRATE;
			sprites[sprite_loop].hit_points_left = 1.5;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MUSHROOM_CLOUD_SPRITE) {
			sprites[sprite_loop].timer = 16;
			sprites[sprite_loop].width = 128, sprites[sprite_loop].height = 128;
			sprites[sprite_loop].frame = MUSHROOM_CLOUD_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			do_damage(x_position_in_pixels, y_position_in_pixels, 128, 128, 10);
			play_relative_sound(NUCLEAR_EXPLOSION_SOUND, sprite_loop);
			if (512 - compute_distance(sprite_loop, -1) > 0) quake_timer += (512 - compute_distance(sprite_loop, -1));
			if (quake_timer > 512) quake_timer = 512;
			}

		else if (sprite_type == HEALTH_1_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_HEALTH_1;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == HEALTH_2_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_HEALTH_2;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == HEALTH_5_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_HEALTH_5;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == HEALTH_10_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_HEALTH_10;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MINIGUN_SPRITE) {
			sprites[sprite_loop].width = 21, sprites[sprite_loop].height = 15;
			sprites[sprite_loop].frame = WORMINATOR_MINIGUN;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 5;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 1;
			}

		else if (sprite_type == BULLETS_SMALL_SPRITE || sprite_type == BULLETS_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == BULLETS_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_BULLETS_SMALL;
			else sprites[sprite_loop].frame = ITEM_BULLETS_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == SHOTGUN_SPRITE) {
			sprites[sprite_loop].width = 24, sprites[sprite_loop].height = 9;
			sprites[sprite_loop].frame = WORMINATOR_SHOTGUN;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 4;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 7;
			}

		else if (sprite_type == SHELLS_SMALL_SPRITE || sprite_type == SHELLS_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == SHELLS_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_SHELLS_SMALL;
			else sprites[sprite_loop].frame = ITEM_SHELLS_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == ROCKET_LAUNCHER_SPRITE) {
			sprites[sprite_loop].width = 24, sprites[sprite_loop].height = 14;
			sprites[sprite_loop].frame = WORMINATOR_ROCKET_LAUNCHER;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 4;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 2;
			}

		else if (sprite_type == ROCKETS_SMALL_SPRITE || sprite_type == ROCKETS_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == ROCKETS_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_ROCKETS_SMALL;
			else sprites[sprite_loop].frame = ITEM_ROCKETS_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == LASER_GUN_SPRITE) {
			sprites[sprite_loop].width = 27, sprites[sprite_loop].height = 10;
			sprites[sprite_loop].frame = WORMINATOR_LASER_GUN;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 2;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 6;
			}

		else if (sprite_type == CELLS_SMALL_SPRITE || sprite_type == CELLS_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == CELLS_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_CELLS_SMALL;
			else sprites[sprite_loop].frame = ITEM_CELLS_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == FLAMETHROWER_SPRITE) {
			sprites[sprite_loop].width = 23, sprites[sprite_loop].height = 10;
			sprites[sprite_loop].frame = WORMINATOR_FLAMETHROWER;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 4;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 6;
			}

		else if (sprite_type == GASOLINE_SMALL_SPRITE || sprite_type == GASOLINE_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == GASOLINE_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_GASOLINE_SMALL;
			else sprites[sprite_loop].frame = ITEM_GASOLINE_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MORTAR_CANNON_SPRITE) {
			sprites[sprite_loop].width = 18, sprites[sprite_loop].height = 19;
			sprites[sprite_loop].frame = WORMINATOR_MORTAR_CANNON;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 7;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels - 3;
			}

		else if (sprite_type == MORTARS_SMALL_SPRITE || sprite_type == MORTARS_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == MORTARS_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_MORTARS_SMALL;
			else sprites[sprite_loop].frame = ITEM_MORTARS_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == BFG_SPRITE) {
			sprites[sprite_loop].width = 29, sprites[sprite_loop].height = 20;
			sprites[sprite_loop].frame = WORMINATOR_BFG;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 2;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels - 4;
			}

		else if (sprite_type == PLASMA_SMALL_SPRITE || sprite_type == PLASMA_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == PLASMA_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_PLASMA_SMALL;
			else sprites[sprite_loop].frame = ITEM_PLASMA_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MINELAYER_SPRITE) {
			sprites[sprite_loop].width = 21, sprites[sprite_loop].height = 17;
			sprites[sprite_loop].frame = WORMINATOR_MINE_LAYER;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 5;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels - 1;
			}

		else if (sprite_type == MINES_SMALL_SPRITE || sprite_type == MINES_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == MINES_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_MINES_SMALL;
			else sprites[sprite_loop].frame = ITEM_MINES_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == RED_KEYCARD_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = RED_KEYCARD;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == GREEN_KEYCARD_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = GREEN_KEYCARD;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == BLUE_KEYCARD_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = BLUE_KEYCARD;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == LETTER_W_SPRITE || sprite_type == LETTER_O_SPRITE || sprite_type == LETTER_R_SPRITE || sprite_type == LETTER_M_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == LETTER_W_SPRITE) sprites[sprite_loop].frame = ITEM_LETTER_W;
			else if (sprite_type == LETTER_O_SPRITE) sprites[sprite_loop].frame = ITEM_LETTER_O;
			else if (sprite_type == LETTER_R_SPRITE) sprites[sprite_loop].frame = ITEM_LETTER_R;
			else sprites[sprite_loop].frame = ITEM_LETTER_M;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == SODA_SIXPACK_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_SODA_SIXPACK;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == DOUGHNUTS_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_DOUGHNUTS;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == BOX_OF_DOUGHNUTS_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_BOX_OF_DOUGHNUTS;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MUD_BEER_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_MUD_BEER;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == DIRT_CHIPS_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_DIRT_CHIPS;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MUD_ICE_CREAM_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_MUD_ICE_CREAM;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MINI_MOUNT_N_DO_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_MINI_MOUNT_N_DO;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MUD_PIE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_MUD_PIE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == BIG_TASTY_BALL_O_DIRT_SPRITE) {
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = ITEM_BIG_TASTY_BALL_O_DIRT;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == LIFE_ESSENCE_SPRITE) {
			sprites[sprite_loop].timer = 24;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 24;
			sprites[sprite_loop].frame = ZZ_ITEM_LIFE_ESSENCE_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
		}

		else if (sprite_type == SMALL_SPINNING_FAN_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = SMALL_FAN;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MEDIUM_SPINNING_FAN_SPRITE) {
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = MEDIUM_FAN;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == LARGE_SPINNING_FAN_SPRITE) {
			sprites[sprite_loop].width = 48, sprites[sprite_loop].height = 48;
			sprites[sprite_loop].frame = LARGE_FAN;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == STARDUST_PARTICLE_SPRITE) {
			sprites[sprite_loop].timer = 8;
			sprites[sprite_loop].width = 1, sprites[sprite_loop].height = 1;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = x_acceleration;
			sprites[sprite_loop].y_acceleration = y_acceleration;
			}

		else if (sprite_type == PUSHABLE_CRATE_SPRITE) {
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = PUSHABLE_CRATE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == PERVERT_MESSAGE_SPRITE) {
			sprites[sprite_loop].timer = 512;
			sprites[sprite_loop].width = 174, sprites[sprite_loop].height = 45;
			sprites[sprite_loop].frame = PERVERT_MESSAGE;
			sprites[sprite_loop].x_position_in_pixels = screen_x_position + 41;
			sprites[sprite_loop].y_position_in_pixels = screen_y_position + 16;
			}

		else if (sprite_type == GREY_DOOR_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 48;
			sprites[sprite_loop].frame = GREY_DOOR_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == RED_DOOR_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 48;
			sprites[sprite_loop].frame = RED_DOOR_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == RED_DOOR_TOP_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 64;
			sprites[sprite_loop].frame = RED_DOOR_03_TOP;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == RED_DOOR_BOTTOM_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 64;
			sprites[sprite_loop].frame = RED_DOOR_03_BOTTOM;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == GREEN_DOOR_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 48;
			sprites[sprite_loop].frame = GREEN_DOOR_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == GREEN_DOOR_TOP_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 64;
			sprites[sprite_loop].frame = GREEN_DOOR_03_TOP;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == GREEN_DOOR_BOTTOM_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 64;
			sprites[sprite_loop].frame = GREEN_DOOR_03_BOTTOM;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == BLUE_DOOR_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 48;
			sprites[sprite_loop].frame = BLUE_DOOR_01;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == WATER_DROP_SPRITE) {
			sprites[sprite_loop].width = 4, sprites[sprite_loop].height = 8;
			sprites[sprite_loop].frame = WATER_DROP;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == BORED_SPRITE) {
			sprites[sprite_loop].width = 0, sprites[sprite_loop].height = 0;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = 0;
			sprites[sprite_loop].y_position_in_pixels = 0;
			}

		else if (sprite_type == BLUE_SPARK_SPAWNER_SPRITE || sprite_type == RED_SPARK_SPAWNER_SPRITE || sprite_type == WHITE_SPARK_SPAWNER_SPRITE || sprite_type == GOLD_SPARK_SPAWNER_SPRITE) {
			sprites[sprite_loop].timer = (rand() % 1024) + 128;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == WATER_DROP_SPAWNER_SPRITE) {
			sprites[sprite_loop].timer = (rand() % 1024) + 128;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == NUCLEAR_BOMB_SPAWNER_SPRITE) {
			sprites[sprite_loop].timer = (rand() % 256) + 128;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == ARCSPARK_SPRITE) {
			sprites[sprite_loop].timer = 0;
			sprites[sprite_loop].width = 0, sprites[sprite_loop].height = 0;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].x_acceleration = (float)((rand() % 20) - 10.00) / 10.00;
			sprites[sprite_loop].y_acceleration = (float)((rand() % 20) - 10.00) / 10.00;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == CIGARETTE_BUTT_SPAWNER_SPRITE) {
			sprites[sprite_loop].timer = (rand() % 1024) + 128;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == FIREWORK_SPAWNER_SPRITE) {
			sprites[sprite_loop].timer = (rand() % 1024) + 1024;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == BOTTLE_ROCKET_SPAWNER_SPRITE) {
			sprites[sprite_loop].timer = (rand() % 1024) + 1024;
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == PLASMA_BULLETS_SMALL_SPRITE || sprite_type == PLASMA_BULLETS_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == PLASMA_BULLETS_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_PLASMA_BULLETS_SMALL;
			else sprites[sprite_loop].frame = ITEM_PLASMA_BULLETS_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == EXPLOSIVE_SHELLS_SMALL_SPRITE || sprite_type == EXPLOSIVE_SHELLS_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == EXPLOSIVE_SHELLS_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_EXPLOSIVE_SHELLS_SMALL;
			else sprites[sprite_loop].frame = ITEM_EXPLOSIVE_SHELLS_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == MICRO_NUKE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_MICRO_NUKE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == WALKING_MINES_SMALL_SPRITE || sprite_type == WALKING_MINES_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == WALKING_MINES_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_WALKING_MINES_SMALL;
			else sprites[sprite_loop].frame = ITEM_WALKING_MINES_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == CHAINSAW_SPRITE) {
			sprites[sprite_loop].width = 41, sprites[sprite_loop].height = 14;
			sprites[sprite_loop].frame = WORMINATOR_CHAINSAW;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels - 4;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 2;
			}

		else if (sprite_type == RAILGUN_SPRITE) {
			sprites[sprite_loop].width = 22, sprites[sprite_loop].height = 8;
			sprites[sprite_loop].frame = WORMINATOR_RAILGUN;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 5;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 8;
			}

		else if (sprite_type == RAILS_SMALL_SPRITE || sprite_type == RAILS_LARGE_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			if (sprite_type == RAILS_SMALL_SPRITE) sprites[sprite_loop].frame = ITEM_RAILS_SMALL;
			else sprites[sprite_loop].frame = ITEM_RAILS_LARGE;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == STARDUSTER_SPRITE) {
			sprites[sprite_loop].width = 26, sprites[sprite_loop].height = 11;
			sprites[sprite_loop].frame = WORMINATOR_STARDUSTER;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels + 3;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels + 5;
			}

		else if (sprite_type == SPIKESTARS_SPRITE) {
			sprites[sprite_loop].width = 16, sprites[sprite_loop].height = 16;
			sprites[sprite_loop].frame = ITEM_SPIKESTARS;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			}

		else if (sprite_type == TANK_SPRITE) {
			sprites[sprite_loop].timer = 128;
			sprites[sprite_loop].width = 96, sprites[sprite_loop].height = 64;
			sprites[sprite_loop].frame = TANK_REST;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == DARK_PALETTE_EFFECT_SPRITE) {
			//sprites[sprite_loop].timer = 128;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == LIGHT_PALETTE_EFFECT_SPRITE) {
			//sprites[sprite_loop].timer = 128;
			sprites[sprite_loop].width = 32, sprites[sprite_loop].height = 32;
			sprites[sprite_loop].frame = 0;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].direction = direction;
			}

		else if (sprite_type == DAMAGE_MARKER) {
			sprites[sprite_loop].frame = 0;//WORM_CANNON_REST;
			sprites[sprite_loop].hit_points_left = .1;
			sprites[sprite_loop].x_position_in_pixels = x_position_in_pixels;
			sprites[sprite_loop].y_position_in_pixels = y_position_in_pixels;
			sprites[sprite_loop].width = x_acceleration;
			sprites[sprite_loop].height = y_acceleration;
			}

		return;
		}
	}
}

/********************\
|** DESTROY SPRITE **|
\********************/
void destroy_sprite(int sprite_number)
{
int sprite_loop;
for (sprite_loop = sprite_number; sprite_loop < number_of_sprites; sprite_loop++) {
	sprites[sprite_loop].sprite_active = sprites[sprite_loop + 1].sprite_active;
	sprites[sprite_loop].sprite_type = sprites[sprite_loop + 1].sprite_type;
	sprites[sprite_loop].in_range = sprites[sprite_loop + 1].in_range;
	sprites[sprite_loop].timer = sprites[sprite_loop + 1].timer;
	sprites[sprite_loop].animation_state = sprites[sprite_loop + 1].animation_state;
	sprites[sprite_loop].width = sprites[sprite_loop + 1].width; 
	sprites[sprite_loop].height = sprites[sprite_loop + 1].height;
	sprites[sprite_loop].action_state = sprites[sprite_loop + 1].action_state;
	sprites[sprite_loop].frame = sprites[sprite_loop + 1].frame;
	sprites[sprite_loop].hit_points_left = sprites[sprite_loop + 1].hit_points_left;
	sprites[sprite_loop].x_position_in_pixels = sprites[sprite_loop + 1].x_position_in_pixels;
	sprites[sprite_loop].y_position_in_pixels = sprites[sprite_loop + 1].y_position_in_pixels;
	sprites[sprite_loop].x_acceleration = sprites[sprite_loop + 1].x_acceleration;
	sprites[sprite_loop].y_acceleration = sprites[sprite_loop + 1].y_acceleration;
	sprites[sprite_loop].direction = sprites[sprite_loop + 1].direction;
	sprites[sprite_loop].rotate_factor = sprites[sprite_loop + 1].rotate_factor;
	}

number_of_sprites--;
}

/*******************\
|** CLEAR SPRITES **|
\*******************/
void clear_sprites()
{
int sprite_loop;
for (sprite_loop = 0; sprite_loop < 1024; sprite_loop++) {
	sprites[sprite_loop].sprite_active = 0;
	sprites[sprite_loop].sprite_type = 0;
	sprites[sprite_loop].in_range = TRUE;
	sprites[sprite_loop].timer = 0;
	sprites[sprite_loop].animation_state = 0;
	sprites[sprite_loop].width = 0;
	sprites[sprite_loop].height = 0;
	sprites[sprite_loop].action_state = 0;
	sprites[sprite_loop].frame = 0;
	sprites[sprite_loop].hit_points_left = 0;
	sprites[sprite_loop].x_position_in_pixels = 0;
	sprites[sprite_loop].y_position_in_pixels = 0;
	sprites[sprite_loop].x_acceleration = 0;
	sprites[sprite_loop].y_acceleration = 0;
	sprites[sprite_loop].direction = 0;
	sprites[sprite_loop].rotate_factor = 0;
	}

number_of_sprites = 0;
}

/********************\
|** UPDATE SPRITES **|
\********************/
void update_sprites()
{
int sprite_loop;

for (sprite_loop = 0; sprite_loop < number_of_sprites; sprite_loop++) {

	if (sprite_loop >= number_of_sprites || sprite_loop >= 1024) break;

	// Kill any sprites that have left the level
	if (sprites[sprite_loop].x_position_in_pixels < -1024 || sprites[sprite_loop].y_position_in_pixels < -1024 || sprites[sprite_loop].x_position_in_pixels > 5120 || sprites[sprite_loop].y_position_in_pixels > 4096) destroy_sprite(sprite_loop);
	
	// One of Worminator's bullets flying in the air.
	if (sprites[sprite_loop].sprite_type == WORMINATOR_BULLET_SPRITE) worminator_bullet_ai(sprite_loop);

	// One of Worminator's rockets flying in the air.
	else if (sprites[sprite_loop].sprite_type == WORMINATOR_ROCKET_SPRITE) worminator_rocket_ai(sprite_loop);

	// One of Worminator's mortars flying in the air.
	else if (sprites[sprite_loop].sprite_type == WORMINATOR_MORTAR_SPRITE) worminator_mortar_ai(sprite_loop);

	// One of Worminator's BFG plasma balls flying in the air.
	else if (sprites[sprite_loop].sprite_type == WORMINATOR_BFG_PLASMA_BALL_SPRITE) worminator_bfg_plasma_ball_ai(sprite_loop);

	// One of Worminator's mines.
	else if (sprites[sprite_loop].sprite_type == WORMINATOR_MINE_SPRITE) worminator_mine_ai(sprite_loop);

	// One of an enemies plasma bullets flying in the air.
	else if (sprites[sprite_loop].sprite_type == ENEMY_PLASMA_BULLET_SPRITE) enemy_plasma_bullet_ai(sprite_loop);

	// One of an enemies laser bolts flying in the air.
	else if (sprites[sprite_loop].sprite_type == ENEMY_LASER_BOLT_SPRITE) enemy_laser_bolt_ai(sprite_loop);

	// One of an enemies small rockets flying in the air.
	else if (sprites[sprite_loop].sprite_type == SMALL_ENEMY_ROCKET_SPRITE) small_enemy_rocket_ai(sprite_loop);

	// One of an enemies large rockets flying in the air.
	else if (sprites[sprite_loop].sprite_type == LARGE_ENEMY_ROCKET_SPRITE) large_enemy_rocket_ai(sprite_loop);

	// One of a mortar gun turret's mortars flying in the air.
	else if (sprites[sprite_loop].sprite_type == ENEMY_MORTAR_SPRITE) enemy_mortar_ai(sprite_loop);

	// One of a deciamter's toxic bulltes flying in the air.
	else if (sprites[sprite_loop].sprite_type == ENEMY_TOXIN_SPRITE) enemy_toxin_ai(sprite_loop);

	// One of Worminator's plasma bullets flying in the air
	else if (sprites[sprite_loop].sprite_type == WORMINATOR_PLASMA_BULLET_SPRITE) worminator_plasma_bullet_ai(sprite_loop);

	// One of Worminator's spikestars flying in the air.
	else if (sprites[sprite_loop].sprite_type == WORMINATOR_SPIKESTAR_SPRITE) worminator_spikestar_ai(sprite_loop);

	// One of Worminator's micro nukes flying in the air.
	else if (sprites[sprite_loop].sprite_type == WORMINATOR_MICRO_NUKE_SPRITE) worminator_micro_nuke_ai(sprite_loop);

	// One of Worminator's walking mines.
	else if (sprites[sprite_loop].sprite_type == WORMINATOR_WALKING_MINE_SPRITE) worminator_walking_mine_ai(sprite_loop);

	// An enemy's heat seeking missile
	else if (sprites[sprite_loop].sprite_type == ENEMY_MISSILE_SPRITE) enemy_missile_ai(sprite_loop);

	// A tapeworm's egg
	else if (sprites[sprite_loop].sprite_type == ENEMY_EGG_SPRITE) small_enemy_rocket_ai(sprite_loop);

	// A firework or bottle rocket
	else if (sprites[sprite_loop].sprite_type == FIREWORK_SPRITE || sprites[sprite_loop].sprite_type == BOTTLE_ROCKET_SPRITE) firework_ai(sprite_loop);

	// A gigantic rocket
	else if (sprites[sprite_loop].sprite_type == GIANT_ROCKET_SPRITE) giant_rocket_ai(sprite_loop);

	// A tank shell from the drivable tank
	else if (sprites[sprite_loop].sprite_type == TANK_SHELL_SPRITE) worminator_rocket_ai(sprite_loop);

	// Any of the following flyup sprites
	else if (sprites[sprite_loop].sprite_type == BONUS_FLYUP_50_POINT_SPRITE || sprites[sprite_loop].sprite_type == BONUS_FLYUP_100_POINT_SPRITE || sprites[sprite_loop].sprite_type == BONUS_FLYUP_250_POINT_SPRITE || sprites[sprite_loop].sprite_type == BONUS_FLYUP_500_POINT_SPRITE) flyup_sprite_ai(sprite_loop);

	// A small spark.  Can be used for snow, bullet hits, blood, rain, water fountains, etc...
	else if (sprites[sprite_loop].sprite_type == SMALL_WHITE_SPARK_SPRITE || sprites[sprite_loop].sprite_type == SMALL_BLUE_SPARK_SPRITE || sprites[sprite_loop].sprite_type == SMALL_RED_SPARK_SPRITE || sprites[sprite_loop].sprite_type == SMALL_GOLD_SPARK_SPRITE) small_spark_ai(sprite_loop);

	// A bubble in the water
	else if (sprites[sprite_loop].sprite_type == WATER_BUBBLE_SPRITE) water_bubble_ai(sprite_loop);

	// A water_splash
	else if (sprites[sprite_loop].sprite_type == WATER_SPLASH_SPRITE) water_splash_ai(sprite_loop);

	// A chunk of shrapnel or a gib
	else if (sprites[sprite_loop].sprite_type == SHRAPNEL_SPRITE || sprites[sprite_loop].sprite_type == GIB_SPRITE) shrapgib_ai(sprite_loop);

	// A flying platform that carries the worminator
	else if (sprites[sprite_loop].sprite_type == FLOATING_PLATFORM_SPRITE) floating_platform_ai(sprite_loop);

	// A blue slime blob
	else if (sprites[sprite_loop].sprite_type == BLUE_SLIME_ENEMY_SPRITE) blue_slime_enemy_ai(sprite_loop);

	// A small running enemy that climbs hills and is pretty smart
	else if (sprites[sprite_loop].sprite_type == SMALL_RUNNER_ENEMY_SPRITE) running_enemy_ai(sprite_loop);

	// An awesome robotic dog that walks back and forth and bites the worminator
	else if (sprites[sprite_loop].sprite_type == ROBOTIC_DOG_ENEMY_SPRITE) robotic_dog_enemy_ai(sprite_loop);

	// A small gun turret
	else if (sprites[sprite_loop].sprite_type == SMALL_GUN_TURRET_ENEMY_SPRITE) small_gun_turret_ai(sprite_loop);

	// A mortar gun turret
	else if (sprites[sprite_loop].sprite_type == MORTAR_GUN_TURRET_ENEMY_SPRITE) mortar_gun_turret_ai(sprite_loop);

	// A big gun turret
	else if (sprites[sprite_loop].sprite_type == BIG_GUN_TURRET_ENEMY_SPRITE) big_gun_turret_ai(sprite_loop);

	// A flying probe
	else if (sprites[sprite_loop].sprite_type == FLYING_PROBE_ENEMY_SPRITE) flying_probe_enemy_ai(sprite_loop);

	// A decimater
	else if (sprites[sprite_loop].sprite_type == DECIMATER_ENEMY_SPRITE) decimater_enemy_ai(sprite_loop);

	// A giant robot
	else if (sprites[sprite_loop].sprite_type == GIANT_ROBOT_ENEMY_SPRITE) giant_robot_enemy_ai(sprite_loop);

	// A mechanical crusher
	else if (sprites[sprite_loop].sprite_type == MECHANICAL_CRUSHER_ENEMY_SPRITE) mechanical_crusher_enemy_ai(sprite_loop);

	// A nuclear worm
	else if (sprites[sprite_loop].sprite_type == NUCLEAR_WORM_ENEMY_SPRITE) nuclear_worm_enemy_ai(sprite_loop);

	// A rebel worm with a laser gun
	else if (sprites[sprite_loop].sprite_type == LASER_REBEL_WORM_ENEMY_SPRITE) laser_rebel_worm_enemy_ai(sprite_loop);

	// A rebel worm with a rocket launcher
	else if (sprites[sprite_loop].sprite_type == ROCKET_REBEL_WORM_ENEMY_SPRITE) rocket_rebel_worm_enemy_ai(sprite_loop);

	// A rebel worm with a rifle
	else if (sprites[sprite_loop].sprite_type == RIFLE_REBEL_WORM_ENEMY_SPRITE) rifle_rebel_worm_enemy_ai(sprite_loop);

	// A big ugly green slime blob that smooshes itself around
	else if (sprites[sprite_loop].sprite_type == BIG_GREEN_SLIME_BLOB_ENEMY_SPRITE) big_green_slime_blob_enemy_ai(sprite_loop);

	// A funny little red slime blob that smooshes itself around and looks like a gumdrop
	else if (sprites[sprite_loop].sprite_type == GUMDROP_ENEMY_SPRITE) gumdrop_enemy_ai(sprite_loop);

	// Either of the two nuclear bombs that can be dropped
	else if (sprites[sprite_loop].sprite_type == BIG_NUCLEAR_BOMB_ENEMY_SPRITE || sprites[sprite_loop].sprite_type == SMALL_NUCLEAR_BOMB_ENEMY_SPRITE) nuclear_bomb_enemy_ai(sprite_loop);

	// A segment of the all powerful fire worm!!!
	else if (sprites[sprite_loop].sprite_type == FIREWORM_SEGMENT_ENEMY_SPRITE) fireworm_segment_enemy_ai(sprite_loop);

	// A nasty flame jet
	else if (sprites[sprite_loop].sprite_type == FLAME_JET_ENEMY_SPRITE) flame_jet_enemy_ai(sprite_loop);

	// A worm cannon
	else if (sprites[sprite_loop].sprite_type == WORM_CANNON_ENEMY_SPRITE) worm_cannon_enemy_ai(sprite_loop);

	// An arab worm
	else if (sprites[sprite_loop].sprite_type == ARAB_WORM_ENEMY_SPRITE) arab_worm_enemy_ai(sprite_loop);

	// A wermaid
	else if (sprites[sprite_loop].sprite_type == WERMAID_ENEMY_SPRITE) wermaid_enemy_ai(sprite_loop);

	// A heavy weapon rebel worm
	else if (sprites[sprite_loop].sprite_type == HEAVY_WEAPON_REBEL_WORM_ENEMY_SPRITE) heavy_weapon_rebel_worm_enemy_ai(sprite_loop);

	// A thug worm
	else if (sprites[sprite_loop].sprite_type == THUG_WORM_ENEMY_SPRITE) thug_worm_enemy_ai(sprite_loop);

	// A punk worm
	else if (sprites[sprite_loop].sprite_type == PUNK_WORM_ENEMY_SPRITE) punk_worm_enemy_ai(sprite_loop);
	
	// A tapeworm with a spear
	else if (sprites[sprite_loop].sprite_type == SPEAR_TAPEWORM_ENEMY_SPRITE) spear_tapeworm_enemy_ai(sprite_loop);

	// A tapeworm with a weirdass egg gun
	else if (sprites[sprite_loop].sprite_type == EGG_TAPEWORM_ENEMY_SPRITE) egg_tapeworm_enemy_ai(sprite_loop);

	// A big rolling boulder
	else if (sprites[sprite_loop].sprite_type == BOULDER_ENEMY_SPRITE) boulder_enemy_ai(sprite_loop);

	// A big stomping foot
	else if (sprites[sprite_loop].sprite_type == STOMPING_FOOT_ENEMY_SPRITE) stomping_foot_enemy_ai(sprite_loop);

	// A flying explosive cigarette butt
	else if (sprites[sprite_loop].sprite_type == CIGARETTE_BUTT_ENEMY_SPRITE) cigarette_butt_enemy_ai(sprite_loop);

	// An awesome gigantic bigass boss!
	else if (sprites[sprite_loop].sprite_type == BOSS_ENEMY_SPRITE) boss_enemy_ai(sprite_loop);

	// A worm girl
	else if (sprites[sprite_loop].sprite_type == WORM_GIRL_SPRITE) worm_girl_ai(sprite_loop);

	// A worm boy
	else if (sprites[sprite_loop].sprite_type == WORM_BOY_SPRITE) worm_boy_ai(sprite_loop);

	// A worm stripper!!!
	else if (sprites[sprite_loop].sprite_type == WORM_STRIPPER_ONE_SPRITE) worm_stripper_one_ai(sprite_loop);

	// A nude blonde worm slut!!!
	else if (sprites[sprite_loop].sprite_type == WORM_BLONDE_NUDE_ONE_SPRITE) worm_blonde_nude_one_ai(sprite_loop);

	// A small (16x16) explosion
	else if (sprites[sprite_loop].sprite_type == SMALL_EXPLOSION_SPRITE) small_explosion_ai(sprite_loop);

	// A medium (32x32) explosion
	else if (sprites[sprite_loop].sprite_type == MEDIUM_EXPLOSION_SPRITE) medium_explosion_ai(sprite_loop);

	// A small (16x32) explosive barrel
	else if (sprites[sprite_loop].sprite_type == SMALL_EXPLOSIVE_BARREL_SPRITE) small_explosive_barrel_ai(sprite_loop);

	// A small (16x32) explosive nuclear crate
	else if (sprites[sprite_loop].sprite_type == SMALL_EXPLOSIVE_NUCLEAR_CRATE_SPRITE) small_explosive_nuclear_crate_ai(sprite_loop);

	// A giant (128x128) mushroom cloud
	else if (sprites[sprite_loop].sprite_type == MUSHROOM_CLOUD_SPRITE) mushroom_cloud_ai(sprite_loop);

	// A BFG plasma ball explosion
	else if (sprites[sprite_loop].sprite_type == BFG_PLASMA_BALL_EXPLOSION_SPRITE) bfg_plasma_ball_explosion_ai(sprite_loop);

	// An exploding car that can be run over by a tank
	else if (sprites[sprite_loop].sprite_type == EXPLODING_CAR_01_SPRITE || sprites[sprite_loop].sprite_type == EXPLODING_CAR_02_SPRITE) exploding_car_ai(sprite_loop);

	// Any of the health packs that the worminator picks up
	else if (sprites[sprite_loop].sprite_type >= HEALTH_1_SPRITE && sprites[sprite_loop].sprite_type <= HEALTH_10_SPRITE) getable_health_ai(sprite_loop);

	// The minigun that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == MINIGUN_SPRITE) minigun_ai(sprite_loop);

	// The bullets used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == BULLETS_SMALL_SPRITE || sprites[sprite_loop].sprite_type == BULLETS_LARGE_SPRITE) getable_bullets_ai(sprite_loop);

	// The shotgun that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == SHOTGUN_SPRITE) shotgun_ai(sprite_loop);

	// The shells used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == SHELLS_SMALL_SPRITE || sprites[sprite_loop].sprite_type == SHELLS_LARGE_SPRITE) getable_shells_ai(sprite_loop);

	// The rocket launcher that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == ROCKET_LAUNCHER_SPRITE) rocket_launcher_ai(sprite_loop);

	// The rockets used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == ROCKETS_SMALL_SPRITE || sprites[sprite_loop].sprite_type == ROCKETS_LARGE_SPRITE) getable_rockets_ai(sprite_loop);

	// The laser gun that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == LASER_GUN_SPRITE) laser_gun_ai(sprite_loop);

	// The cells used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == CELLS_SMALL_SPRITE || sprites[sprite_loop].sprite_type == CELLS_LARGE_SPRITE) getable_cells_ai(sprite_loop);

	// The flamethrower that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == FLAMETHROWER_SPRITE) flamethrower_ai(sprite_loop);

	// The gas used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == GASOLINE_SMALL_SPRITE || sprites[sprite_loop].sprite_type == GASOLINE_LARGE_SPRITE) getable_gasoline_ai(sprite_loop);

	// The mortar cannon that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == MORTAR_CANNON_SPRITE) mortar_cannon_ai(sprite_loop);

	// The mortars used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == MORTARS_SMALL_SPRITE || sprites[sprite_loop].sprite_type == MORTARS_LARGE_SPRITE) getable_mortars_ai(sprite_loop);

	// The BFG that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == BFG_SPRITE) bfg_ai(sprite_loop);

	// The plasma used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == PLASMA_SMALL_SPRITE || sprites[sprite_loop].sprite_type == PLASMA_LARGE_SPRITE) getable_plasma_ai(sprite_loop);

	// The minelayer that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == MINELAYER_SPRITE) minelayer_ai(sprite_loop);

	// The mines used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == MINES_SMALL_SPRITE || sprites[sprite_loop].sprite_type == MINES_LARGE_SPRITE) getable_mines_ai(sprite_loop);

	// A red keycard
	else if (sprites[sprite_loop].sprite_type == RED_KEYCARD_SPRITE) red_keycard_ai(sprite_loop);

	// A green keycard
	else if (sprites[sprite_loop].sprite_type == GREEN_KEYCARD_SPRITE) green_keycard_ai(sprite_loop);

	// A blue keycard
	else if (sprites[sprite_loop].sprite_type == BLUE_KEYCARD_SPRITE) blue_keycard_ai(sprite_loop);

	// A W, O, R, or M letter that the worminator can pick up
	else if (sprites[sprite_loop].sprite_type == LETTER_W_SPRITE || sprites[sprite_loop].sprite_type == LETTER_O_SPRITE || sprites[sprite_loop].sprite_type == LETTER_R_SPRITE || sprites[sprite_loop].sprite_type == LETTER_M_SPRITE) letter_ai(sprite_loop);

	// A soda sixpack
	else if (sprites[sprite_loop].sprite_type == SODA_SIXPACK_SPRITE) soda_sixpack_ai(sprite_loop);

	// Some doughnuts
	else if (sprites[sprite_loop].sprite_type == DOUGHNUTS_SPRITE) doughnuts_ai(sprite_loop);

	// A box of doughnuts
	else if (sprites[sprite_loop].sprite_type == BOX_OF_DOUGHNUTS_SPRITE) box_of_doughnuts_ai(sprite_loop);

	// A bottle of mud beer
	else if (sprites[sprite_loop].sprite_type == MUD_BEER_SPRITE) mud_beer_ai(sprite_loop);

	// A bag of dirt chips
	else if (sprites[sprite_loop].sprite_type == DIRT_CHIPS_SPRITE) dirt_chips_ai(sprite_loop);

	// A cone of mud ice cream
	else if (sprites[sprite_loop].sprite_type == MUD_ICE_CREAM_SPRITE) mud_ice_cream_ai(sprite_loop);

	// A can of mini mount n do
	else if (sprites[sprite_loop].sprite_type == MINI_MOUNT_N_DO_SPRITE) mini_mount_n_do_ai(sprite_loop);

	// A slice of mud pie
	else if (sprites[sprite_loop].sprite_type == MUD_PIE_SPRITE) mud_pie_ai(sprite_loop);

	// A big tasty ball o dirt
	else if (sprites[sprite_loop].sprite_type == BIG_TASTY_BALL_O_DIRT_SPRITE) big_tasty_ball_o_dirt_ai(sprite_loop);

	// A life essence dropped by an enemy
	else if (sprites[sprite_loop].sprite_type == LIFE_ESSENCE_SPRITE) getable_health_ai(sprite_loop);

	// Any of the spinning fans
	else if (sprites[sprite_loop].sprite_type == SMALL_SPINNING_FAN_SPRITE || sprites[sprite_loop].sprite_type == MEDIUM_SPINNING_FAN_SPRITE || sprites[sprite_loop].sprite_type == LARGE_SPINNING_FAN_SPRITE) basic_spinning_sprite_ai(sprite_loop);

	// A stardust particle
	else if (sprites[sprite_loop].sprite_type == STARDUST_PARTICLE_SPRITE) stardust_particle_ai(sprite_loop);

	// A pushable crate that you can stand on
	else if (sprites[sprite_loop].sprite_type == PUSHABLE_CRATE_SPRITE) pushable_crate_ai(sprite_loop);

	// The pervert message
	else if (sprites[sprite_loop].sprite_type == PERVERT_MESSAGE_SPRITE) pervert_message_ai(sprite_loop);

	// A grey door
	else if (sprites[sprite_loop].sprite_type == GREY_DOOR_SPRITE) grey_door_ai(sprite_loop);

	// A red door
	else if (sprites[sprite_loop].sprite_type == RED_DOOR_SPRITE) red_door_ai(sprite_loop);

	// A top half of a two part red door
	else if (sprites[sprite_loop].sprite_type == RED_DOOR_TOP_SPRITE) red_door_top_ai(sprite_loop);

	// A bottom half of a two part red door
	else if (sprites[sprite_loop].sprite_type == RED_DOOR_BOTTOM_SPRITE) red_door_bottom_ai(sprite_loop);

	// A green door
	else if (sprites[sprite_loop].sprite_type == GREEN_DOOR_SPRITE) green_door_ai(sprite_loop);

	// A top half of a two part green door
	else if (sprites[sprite_loop].sprite_type == GREEN_DOOR_TOP_SPRITE) green_door_top_ai(sprite_loop);

	// A bottom half of a two part green door
	else if (sprites[sprite_loop].sprite_type == GREEN_DOOR_BOTTOM_SPRITE) green_door_bottom_ai(sprite_loop);

	// A blue door
	else if (sprites[sprite_loop].sprite_type == BLUE_DOOR_SPRITE) blue_door_ai(sprite_loop);

	// A water drop 
	else if (sprites[sprite_loop].sprite_type == WATER_DROP_SPRITE) water_drop_ai(sprite_loop);

	// A bored animation thingy
	else if (sprites[sprite_loop].sprite_type == BORED_SPRITE) bored_sprite_ai(sprite_loop);

	// A spark spawner of any color
	else if (sprites[sprite_loop].sprite_type == BLUE_SPARK_SPAWNER_SPRITE || sprites[sprite_loop].sprite_type == RED_SPARK_SPAWNER_SPRITE || sprites[sprite_loop].sprite_type == WHITE_SPARK_SPAWNER_SPRITE || sprites[sprite_loop].sprite_type == GOLD_SPARK_SPAWNER_SPRITE) spark_spawner_ai(sprite_loop);

	// A water drop spawner
	else if (sprites[sprite_loop].sprite_type == WATER_DROP_SPAWNER_SPRITE) water_drop_spawner_ai(sprite_loop);

	// A nuclear bomb spawner
	else if (sprites[sprite_loop].sprite_type == NUCLEAR_BOMB_SPAWNER_SPRITE) nuclear_bomb_spawner_ai(sprite_loop);

	// An arcspark
	else if (sprites[sprite_loop].sprite_type == ARCSPARK_SPRITE) arcspark_ai(sprite_loop);

	// A cigarette butt spawner
	else if (sprites[sprite_loop].sprite_type == CIGARETTE_BUTT_SPAWNER_SPRITE) cigarette_butt_spawner_ai(sprite_loop);

	// A firework or bottle rocket
	else if (sprites[sprite_loop].sprite_type == FIREWORK_SPAWNER_SPRITE || sprites[sprite_loop].sprite_type == BOTTLE_ROCKET_SPAWNER_SPRITE) firework_spawner_ai(sprite_loop);

	// The plasma bullets used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == PLASMA_BULLETS_SMALL_SPRITE || sprites[sprite_loop].sprite_type == PLASMA_BULLETS_LARGE_SPRITE) getable_plasma_bullets_ai(sprite_loop);

	// The explosive shells used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == EXPLOSIVE_SHELLS_SMALL_SPRITE || sprites[sprite_loop].sprite_type == EXPLOSIVE_SHELLS_LARGE_SPRITE) getable_explosive_shells_ai(sprite_loop);

	// The micro nuke used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == MICRO_NUKE_SPRITE) getable_micro_nuke_ai(sprite_loop);

	// The walking mines used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == WALKING_MINES_SMALL_SPRITE || sprites[sprite_loop].sprite_type == WALKING_MINES_LARGE_SPRITE) getable_walking_mines_ai(sprite_loop);

	// A chainsaw
	else if (sprites[sprite_loop].sprite_type == CHAINSAW_SPRITE) chainsaw_ai(sprite_loop);

	// A railgun
	else if (sprites[sprite_loop].sprite_type == RAILGUN_SPRITE) railgun_ai(sprite_loop);

	// The rails used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == RAILS_SMALL_SPRITE || sprites[sprite_loop].sprite_type == RAILS_LARGE_SPRITE) getable_rails_ai(sprite_loop);

	// A starduster weapon
	else if (sprites[sprite_loop].sprite_type == STARDUSTER_SPRITE) starduster_ai(sprite_loop);

	// The spikestars used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == SPIKESTARS_SPRITE) getable_spikestars_ai(sprite_loop);

	// The spikestars used for ammo that the worminator picks up
	else if (sprites[sprite_loop].sprite_type == TANK_SPRITE) tank_ai(sprite_loop);

	// Palette effect sprites
	else if (sprites[sprite_loop].sprite_type == DARK_PALETTE_EFFECT_SPRITE) palette_effect_ai(sprite_loop);
	else if (sprites[sprite_loop].sprite_type == LIGHT_PALETTE_EFFECT_SPRITE) palette_effect_ai(sprite_loop);
	}
}

/********************************\
|** SPRITE IS TOUCHING PLAYER? **|
\********************************/
int sprite_is_touching_player(int sprite_number)
{
int sx, sy, sw, sh, px, py;

if (player.health_bars_left < 1) return FALSE;

sx = (int)sprites[sprite_number].x_position_in_pixels;
sy = (int)sprites[sprite_number].y_position_in_pixels;
sw = sprites[sprite_number].width;
sh = sprites[sprite_number].height;

px = (int)player.x_position_in_pixels;
if (player.is_ducking == FALSE) py = (int)player.y_position_in_pixels;
else py = (int)player.y_position_in_pixels + 16;

// Since most checks will fail, if we can drop most calls withough doing any compex checks,
// we should get a lot of speed gain.  This checks to see if the worm is near the sprite or not.
if (sx > px && sx - px >= 32) return FALSE;
else if (sx <= px && px - sx >= sw) return FALSE;
if (player.is_ducking == FALSE && sy > py && sy - py >= 32) return FALSE;
else if (player.is_ducking == TRUE && sy > py && sy - py >= 16) return FALSE;
else if (sy <= py && py - sy >= sh) return FALSE;

return TRUE;
}

/***************\
|** DO DAMAGE **|
\***************/
void do_damage(int x, int y, int w, int h, float damage_amount)
{
char do_damage;
int sprite_loop;
int sx, sy, sw, sh;
int px = player.x_position_in_pixels, py = player.y_position_in_pixels;

// Check player
if (damage_amount >= 1) {
	do_damage = TRUE;
	if (x > px && x - px >= 32) do_damage = FALSE;
	else if (x <= px && px - x >= w) do_damage = FALSE;
	if (y > py && y - py >= 32) do_damage = FALSE;
	else if (y <= py && py - y >= h) do_damage = FALSE;
	if (do_damage == TRUE) hurt_player((char)(damage_amount * -1));
	}

// Check all sprites
for (sprite_loop = 0; sprite_loop < number_of_sprites; sprite_loop++) {
	if (sprites[sprite_loop].hit_points_left > 0) {
		do_damage = TRUE;

		sx = sprites[sprite_loop].x_position_in_pixels;
		sy = sprites[sprite_loop].y_position_in_pixels;
		sw = sprites[sprite_loop].width;
		sh = sprites[sprite_loop].height;

		// This is the actual collision detection
		if (x > sx && x - sx >= sw) do_damage = FALSE;
		else if (x <= sx && sx - x >= w) do_damage = FALSE;
		if (y > sy && y - sy >= sh) do_damage = FALSE;
		else if (y <= sy && sy - y >= h) do_damage = FALSE;

		if (do_damage == TRUE) {
			if (damage_amount == 1234) {
				if (sprites[sprite_loop].height <= 32 && sprites[sprite_loop].x_acceleration * player.x_acceleration < 0) sprites[sprite_loop].hit_points_left -= damage_amount;
				}
			else sprites[sprite_loop].hit_points_left -= damage_amount;
			}
		}
	}
}

/*******************************\
|** SPRITE IS TOUCHING SPRITE **|
\*******************************/
int sprite_is_touching_sprite(int sprite_number, char flag)
{
char sprite_hit;
int sprite_loop;
int msx, msy, msw, msh;
int sx, sy, sw, sh;

// Flag notes
// 0 = return all sprites
// 1 = return only damageable sprites

// These are the coordinates of the master sprite we are testing against
msx = sprites[sprite_number].x_position_in_pixels;
msy = sprites[sprite_number].y_position_in_pixels;
msw = sprites[sprite_number].width;
msh = sprites[sprite_number].height;

// Check all sprites
for (sprite_loop = 0; sprite_loop < number_of_sprites; sprite_loop++) {
	if (flag == 0 || sprites[sprite_loop].hit_points_left > 0) {
		sprite_hit = TRUE;
		sx = sprites[sprite_loop].x_position_in_pixels;
		sy = sprites[sprite_loop].y_position_in_pixels;
		sw = sprites[sprite_loop].width;
		sh = sprites[sprite_loop].height;

		// This is the actual collision detection
		if (msx > sx && msx - sx >= sw) sprite_hit = FALSE;
		else if (msx <= sx && sx - msx >= msw) sprite_hit = FALSE;
		if (msy > sy && msy - sy >= sh) sprite_hit = FALSE;
		else if (msy <= sy && sy - msy >= msh) sprite_hit = FALSE;

		if (sprite_hit == TRUE && sprite_loop != sprite_number) {
			if (flag == 0) return sprite_loop;
			else if (flag == 1 && sprites[sprite_loop].hit_points_left > 0) return sprite_loop;
			}
		}
	}

// No sprite was hit if we got here
return -1;
}

/*********************************\
|** CHECK SPRITE TURINIG ARROWS **|
\*********************************/
void check_sprite_turning_arrows(int sprite_number, char flag, float x_speed_to_set, float y_speed_to_set)
{
int tile_hit;
int sx, sy;

// Flag notes
// 0 = Check all arrow types
// 1 = Check all arrow types, but use special code on diagonal arrows that change x direction
// 2 = Check only diagonals and left and right arrows
// 3 = Check only cardnal direction arrows
// 4 = Check only diagonals
// 5 = Check only left and right arrows
// 6 = Check only up and down arrows

if (sprites[sprite_number].sprite_type == ROBOTIC_DOG_ENEMY_SPRITE) {
	sx = sprites[sprite_number].x_position_in_pixels;
	sy = sprites[sprite_number].y_position_in_pixels - 8;
	}
else if (sprites[sprite_number].sprite_type == FLYING_PROBE_ENEMY_SPRITE) {
	sx = sprites[sprite_number].x_position_in_pixels + 4;
	sy = sprites[sprite_number].y_position_in_pixels + 4;
	}
else if (sprites[sprite_number].sprite_type == FIREWORM_SEGMENT_ENEMY_SPRITE) {
	sx = sprites[sprite_number].x_position_in_pixels - 4;
	sy = sprites[sprite_number].y_position_in_pixels;
	}
else {
	sx = sprites[sprite_number].x_position_in_pixels;
	sy = sprites[sprite_number].y_position_in_pixels;
	}

tile_hit = worminator_map.info_tile_grid[(int)(sx / 16)][(int)(sy / 16)];
if (worminator_map.info_tile_grid[(int)((sx + 15) / 16)][(int)(sy / 16)] != tile_hit) return;
if (worminator_map.info_tile_grid[(int)(sx / 16)][(int)((sy + 15) / 16)] != tile_hit) return;

if (tile_hit < up_turning_point_info_tile || tile_hit > down_right_turning_point_info_tile) return;

if (flag == 0) {
	// Set these to zero for simpler code
	sprites[sprite_number].x_acceleration = 0;
	sprites[sprite_number].y_acceleration = 0;

	// Check the four cardinal direction arrows
	if (tile_hit == up_turning_point_info_tile) sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
	else if (tile_hit == down_turning_point_info_tile) sprites[sprite_number].y_acceleration = y_speed_to_set;
	else if (tile_hit == right_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set, sprites[sprite_number].direction = 0;
	else if (tile_hit == left_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set * -1, sprites[sprite_number].direction = 1;

	// Check the four multidirectional arrows
	else if (tile_hit == up_right_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
		sprites[sprite_number].x_acceleration = x_speed_to_set;
		sprites[sprite_number].direction = 0;
		}
	else if (tile_hit == down_left_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set;
		sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
		sprites[sprite_number].direction = 1;
		}
	else if (tile_hit == up_left_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
		sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
		sprites[sprite_number].direction = 1;
		}
	else if (tile_hit == down_right_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set;
		sprites[sprite_number].x_acceleration = x_speed_to_set;
		sprites[sprite_number].direction = 0;
		}

	// There is no need to continue on with this function and waste 6 ifs
	return;
	}

if (flag == 1) {
	// Set these to zero for simpler code
	sprites[sprite_number].x_acceleration = 0;
	sprites[sprite_number].y_acceleration = 0;

	// Check the four cardinal direction arrows
	if (tile_hit == up_turning_point_info_tile) sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
	else if (tile_hit == down_turning_point_info_tile) sprites[sprite_number].y_acceleration = y_speed_to_set;
	else if (tile_hit == right_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set, sprites[sprite_number].direction = 0;
	else if (tile_hit == left_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set * -1, sprites[sprite_number].direction = 1;

	// Check the four multidirectional arrows
	if (sprites[sprite_number].direction == 0) {
		if (tile_hit == up_right_turning_point_info_tile) {
			sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
			sprites[sprite_number].x_acceleration = x_speed_to_set;
			}
		else if (tile_hit == down_left_turning_point_info_tile) {
			sprites[sprite_number].x_acceleration = x_speed_to_set;
			sprites[sprite_number].y_acceleration = 0;
			}
		else if (tile_hit == up_left_turning_point_info_tile) {
			sprites[sprite_number].x_acceleration = x_speed_to_set;
			sprites[sprite_number].y_acceleration = 0;
			}
		else if (tile_hit == down_right_turning_point_info_tile) {
			sprites[sprite_number].y_acceleration = y_speed_to_set;
			sprites[sprite_number].x_acceleration = x_speed_to_set;
			}

		}
	if (sprites[sprite_number].direction == 1) {
		if (tile_hit == up_right_turning_point_info_tile) {
			sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
			sprites[sprite_number].y_acceleration = 0;
			}
		else if (tile_hit == down_left_turning_point_info_tile) {
			sprites[sprite_number].y_acceleration = y_speed_to_set;
			sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
			}
		else if (tile_hit == up_left_turning_point_info_tile) {
			sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
			sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
			}
		else if (tile_hit == down_right_turning_point_info_tile) {
			sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
			sprites[sprite_number].y_acceleration = y_speed_to_set;
			}
		}

	// There is no need to continue on with this function and waste 5 ifs
	return;
	}

if (flag == 2) {
	// Set these to zero for simpler code
	sprites[sprite_number].x_acceleration = 0;
	sprites[sprite_number].y_acceleration = 0;

	// Check the four cardinal direction arrows
	if (tile_hit == right_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set, sprites[sprite_number].direction = 0;
	else if (tile_hit == left_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set * -1, sprites[sprite_number].direction = 1;

	// Check the four multidirectional arrows
	else if (tile_hit == up_right_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
		sprites[sprite_number].x_acceleration = x_speed_to_set;
		sprites[sprite_number].direction = 0;
		}
	else if (tile_hit == down_left_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set;
		sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
		sprites[sprite_number].direction = 1;
		}
	else if (tile_hit == up_left_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
		sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
		sprites[sprite_number].direction = 1;
		}
	else if (tile_hit == down_right_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set;
		sprites[sprite_number].x_acceleration = x_speed_to_set;
		sprites[sprite_number].direction = 0;
		}

	// There is no need to continue on with this function and waste 4 ifs
	return;
	}

if (flag == 3) {
	// Set these to zero for simpler code
	sprites[sprite_number].x_acceleration = 0;
	sprites[sprite_number].y_acceleration = 0;

	// Check the four cardinal direction arrows
	if (tile_hit == up_turning_point_info_tile) sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
	else if (tile_hit == down_turning_point_info_tile) sprites[sprite_number].y_acceleration = y_speed_to_set;
	else if (tile_hit == right_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set, sprites[sprite_number].direction = 0;
	else if (tile_hit == left_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set * -1, sprites[sprite_number].direction = 1;

	// There is no need to continue on with this function and waste 3 ifs
	return;
	}

if (flag == 4) {
	// Check the four multidirectional arrows
	if (tile_hit == up_right_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
		sprites[sprite_number].x_acceleration = x_speed_to_set;
		sprites[sprite_number].direction = 0;
		}
	else if (tile_hit == down_left_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set;
		sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
		sprites[sprite_number].direction = 1;
		}
	else if (tile_hit == up_left_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
		sprites[sprite_number].x_acceleration = x_speed_to_set * -1;
		sprites[sprite_number].direction = 1;
		}
	else if (tile_hit == down_right_turning_point_info_tile) {
		sprites[sprite_number].y_acceleration = y_speed_to_set;
		sprites[sprite_number].x_acceleration = x_speed_to_set;
		sprites[sprite_number].direction = 0;
		}

	// There is no need to continue on with this function and waste 2 ifs
	return;
	}

if (flag == 5) {
	// Set these to zero for simpler code
	sprites[sprite_number].x_acceleration = 0;
	sprites[sprite_number].y_acceleration = 0;

	// Check the four cardinal direction arrows
	if (tile_hit == right_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set, sprites[sprite_number].direction = 0;
	else if (tile_hit == left_turning_point_info_tile) sprites[sprite_number].x_acceleration = x_speed_to_set * -1, sprites[sprite_number].direction = 1;

	// There is no need to continue on with this function and waste an if
	return;
	}

if (flag == 6) {
	// Set these to zero for simpler code
	sprites[sprite_number].x_acceleration = 0;
	sprites[sprite_number].y_acceleration = 0;

	// Check the four cardinal direction arrows
	if (tile_hit == up_turning_point_info_tile) sprites[sprite_number].y_acceleration = y_speed_to_set * -1;
	else if (tile_hit == down_turning_point_info_tile) sprites[sprite_number].y_acceleration = y_speed_to_set;
	}

}

/*********************************\
|** CHECK POINT COLLISIONS GRID **|
\*********************************/
int check_point_collisions_grid(int sprite_number, int x, int y, char type_flag)
{
char spawn_loop;
int tile_hit;

// Type flag notes:
// 0 = object counts as an enemy (block enemy tiles work)
// 1 = object counts as a projectile (breaks breakable walls)
// 2 = object counts as a projectile, but won't break breakable walls
// 3 = object has advanced ai (return true for solid or the value of the tile)
// 4 = object is "other" (does none of the above)

tile_hit = worminator_map.info_tile_grid[x / 16][y / 16];

if (tile_hit == blank_info_tile) return FALSE;

if (tile_hit == solid_info_tile) return TRUE;

if (sprites[sprite_number].x_acceleration < 0) {
	if (tile_hit == solid_from_right_no_ammo_info_tile) return TRUE;
	if (tile_hit == solid_from_right_allow_ammo_info_tile && type_flag != 1 && type_flag != 2) return TRUE;
	}
else if (sprites[sprite_number].x_acceleration > 0) {
	if (tile_hit == solid_from_left_no_ammo_info_tile) return TRUE;
	if (tile_hit == solid_from_left_allow_ammo_info_tile && type_flag != 1 && type_flag != 2) return TRUE;
	}

if (sprites[sprite_number].y_acceleration < 0) {
	if (tile_hit == solid_from_bottom_no_ammo_info_tile) return TRUE;
	if (tile_hit == solid_from_bottom_allow_ammo_info_tile && type_flag != 1 && type_flag != 2) return TRUE;
	}
else if (sprites[sprite_number].y_acceleration > 0) {
	if (tile_hit == solid_from_top_no_ammo_info_tile || tile_hit == solid_from_top_no_drop_info_tile) return TRUE;
	if (tile_hit == solid_from_top_allow_ammo_info_tile && type_flag != 1 && type_flag != 2) return TRUE;
	}

if (tile_hit == painful_from_top_info_tile) return TRUE;
if (tile_hit == painful_from_bottom_info_tile) return TRUE;
if (type_flag != 3 && type_flag != 0) {
	if (tile_hit == slope_up_left_to_right_45_info_tile) return TRUE;
	if (tile_hit == slope_up_left_to_right_225_left_info_tile) return FALSE;
	if (tile_hit == slope_up_left_to_right_225_right_info_tile) return TRUE;
	if (tile_hit == slope_up_right_to_left_45_info_tile) return TRUE;
	if (tile_hit == slope_up_right_to_left_225_left_info_tile) return TRUE;
	if (tile_hit == slope_up_right_to_left_225_right_info_tile) return FALSE;
	if (tile_hit == slope_filler_info_tile) return TRUE;
	}
else if (type_flag == 3) {
	if (tile_hit == slope_up_left_to_right_45_info_tile) return slope_up_left_to_right_45_info_tile;
	if (tile_hit == slope_up_left_to_right_225_left_info_tile) return slope_up_left_to_right_225_left_info_tile;
	if (tile_hit == slope_up_left_to_right_225_right_info_tile) return slope_up_left_to_right_225_right_info_tile;
	if (tile_hit == slope_up_right_to_left_45_info_tile) return slope_up_right_to_left_45_info_tile;
	if (tile_hit == slope_up_right_to_left_225_left_info_tile) return slope_up_right_to_left_225_left_info_tile;
	if (tile_hit == slope_up_right_to_left_225_right_info_tile) return slope_up_right_to_left_225_right_info_tile;
	if (tile_hit == slope_filler_info_tile) return slope_filler_info_tile;
	}
if (tile_hit == breakable_wall_info_tile && type_flag == 1) {
	for (spawn_loop = 0; spawn_loop < 16; spawn_loop++) spawn_sprite(SMALL_WHITE_SPARK_SPRITE, ((x / 16) * 16) + 8,  ((y / 16) * 16) + 8, (float)((rand() % 20) - 10.00) / 10.00, (float)((rand() % 20) - 10.00) / 10.00, 0);
	worminator_map.foreground_tile_grid[x / 16][y / 16] = 0;
	worminator_map.info_tile_grid[x / 16][y / 16] = blank_info_tile;
	return TRUE;
	}
else if (tile_hit == breakable_wall_info_tile && type_flag != 1) return TRUE;
if (tile_hit == block_enemy_info_tile && (type_flag == 0 || type_flag == 3)) return TRUE;

else if (tile_hit == conveyor_belt_right_info_tile) return TRUE;
else if (tile_hit == conveyor_belt_left_info_tile) return TRUE;

else if (tile_hit == half_slippery_info_tile) return TRUE;
else if (tile_hit == mostly_slippery_info_tile) return TRUE;

// If we GOT to here, there was no collision with anything.
return FALSE;
}

/*********************\
|** SPAWN SHRAPGIBS **|
\*********************/
void spawn_shrapgibs(int x, int y, unsigned char number_of_shraps, unsigned char number_of_gibs)
{
int spawn_loop;
int numshrap = number_of_shraps, numgib = number_of_gibs;

if (wormy_config.ekg_mode == TRUE) { numshrap *= 8; numgib *= 8; }

for (spawn_loop = 0; spawn_loop < numshrap; spawn_loop++) {
	spawn_sprite(SHRAPNEL_SPRITE, x, y, (float)((rand() % 20) - 10) / 10.00 * 1.5, (float)((rand() % 20) - 10) / 10.00 * 1.5, 0);
	}

for (spawn_loop = 0; spawn_loop < numgib; spawn_loop++) {
	spawn_sprite(GIB_SPRITE, x, y, (float)((rand() % 20) - 10) / 10.00 * 1.5, (float)((rand() % 20) - 10) / 10.00 * 1.5, 0);
	}
}

/********************\
|** SPAWN STARDUST **|
\********************/
void spawn_stardust(int x, int y, float x_speed, float y_speed, unsigned char starting_color, unsigned char final_color, unsigned char path_type, unsigned char number_of_stardust_particles)
{
unsigned char spawn_loop;
int sprite_starter = number_of_sprites;

if (wormy_config.display_particles == FALSE) return;
if (wormy_config.particle_detail == 1) {
	if (number_of_stardust_particles == 1 && (rand() % 20) >= 10) return;
	else if (number_of_stardust_particles != 1) number_of_stardust_particles = number_of_stardust_particles / 2;
	}

// Spawn all the particles and set up all the variables
for (spawn_loop = 0; spawn_loop < number_of_stardust_particles; spawn_loop++) {
	if (number_of_sprites >= 1023) return;
	spawn_sprite(STARDUST_PARTICLE_SPRITE, x, y, x_speed, y_speed, 0);
	sprites[sprite_starter + spawn_loop].frame = starting_color;
	sprites[sprite_starter + spawn_loop].rotate_factor = final_color;
	sprites[sprite_starter + spawn_loop].action_state = path_type;
	}
}

/*************************\
|** OUT OF PLAYER RANGE **|
\*************************/
char out_of_player_range(int sprite_number)
{
int sx = sprites[sprite_number].x_position_in_pixels + sprites[sprite_number].width / 2, sy = sprites[sprite_number].y_position_in_pixels + sprites[sprite_number].height / 2;
int px = player.x_position_in_pixels + 16, py = player.y_position_in_pixels + 16;
int scrw = screen_width, scrh = screen_height;
char truth = FALSE;

// Fudge the screen width/height for a demo
if (recording_demo || playing_demo) { screen_width = 640;  screen_height = 480; }

if (abs(px - sx) > tranx(192) || abs(py - sy) > trany(128)) truth = TRUE;
else if (abs(px - sx) > tranx(128) && abs(py - sy) > trany(128)) truth = TRUE;

// Unfudge the screen width/height
screen_width = scrw;  screen_height = scrh;

return truth;
}

/**********************\
|** COMPUTE DISTANCE **|
\**********************/
int compute_distance(int thing1, int thing2)
{
float x1 = -512, y1 = 0, x2 = 0, y2 = 0;

// Move the player to spot 1 if nessicary
if (thing2 == -1) {
	thing2 = thing1;
	thing1 = -1;
	}
if (thing1 == -1) {
	x1 = player.x_position_in_pixels;
	y1 = player.y_position_in_pixels;
	}
else if (thing1 >= 0 && thing1 < number_of_sprites) {
	x1 = sprites[thing1].x_position_in_pixels;
	y1 = sprites[thing1].y_position_in_pixels;
	}
if (thing2 >= 0 && thing2 < number_of_sprites) {
	x2 = sprites[thing2].x_position_in_pixels;
	y2 = sprites[thing2].y_position_in_pixels;
	}
// HMM shouldn't that read -512 ? Also should we not add an else to both
// constructions above and throw an allert there and then abort?
if (x1 != 512) return (int)(sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)));
else return 0;
}

/**************\
|** POOF OUT **|
\**************/
void poof_out(int x, int y, int frame)
{
int i, j;

for (i = 0; i < ((BITMAP *)(worminator_data_file[frame].dat))->w; i++) {
	for (j = 0; j < ((BITMAP *)(worminator_data_file[frame].dat))->h; j++) {
		if (((short *)((BITMAP *)(worminator_data_file[frame].dat))->line[j])[i] != 0) spawn_stardust(x + i, y + j, 0, 0, ((short *)((BITMAP *)(worminator_data_file[frame].dat))->line[j])[i], ((short *)((BITMAP *)(worminator_data_file[frame].dat))->line[j])[i] + 5, 1, 1);
		}
	}
}
